/**
 * Created by fuhao.li on 2016/12/6.
 */

$(document).ready(function () {
    var url = window.location.href;
    var param = url.indexOf('=');
    if (param > -1) {
        var userId = getUrlParam("userId");
        var apiHost = getUrlParam("apiHost");
        var userType = getUrlParam("userType");//1：运营人员   2：主播   3：普通用户  4. 客服人员  5. 经纪人
        if (userId == null) {
            toast("用户ID为空");
        } else {
            getUserJsonData(apiHost, userId, userType)
        }
    } else {
        toast("缺少参数");
    }

});
//获取url中的参数
function getUrlParam(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
    var r = window.location.search.substr(1).match(reg); //匹配目标参数
    if (r != null) return unescape(r[2]);
    return null; //返回参数值
}

//获取JSON 数据
function getUserJsonData(apiHost, userId, userType) {
    var url = apiHost + "/zone/user_medal/" + userId;
    $.getJSON(url,
        function (data) {
            if (data != null) {
                // console.log(data);
                toObj(data, userType);
            } else {
                toast("Result data == null");
            }
        });
}

//解析Json
function toObj(data, userType) {
    var allArray = data['data'];
    var starArray = [];
    var mArray = [];
    var userArray = [];
    //排序
    allArray = sortByKey(allArray, 'award');
    var contStart = 0;
    var contM = 0;
    var contUser = 0;
    for (var i = 0; i < allArray.length; i++) {
        var type = allArray[i]['type'];
        var is_mvip = allArray[i]['is_mvip'];
        if (is_mvip) {
            mArray.push(allArray[i]);
            if (allArray[i]['award']) {
                contM++;
            }
        } else if (type == 2) { //2主播
            if (allArray[i]['status']) {
                starArray.push(allArray[i]);
                if (allArray[i]['award']) {
                    contStart++;
                }
            }
        } else if (type == 1) {//1 用户
            if (allArray[i]['status']) {
                userArray.push(allArray[i]);
                if (allArray[i]['award']) {
                    contUser++;
                }
            }
        }
    }
    // console.log(allArray);
    // console.log(mArray);
    // console.log(userArray);
    if (starArray.length > 0 && userType == 2) {
        insertDiv("starsDiv", "主播徽章", contStart, starArray)
    }
    if (contM == 0) {
        mArray.length = 0;
    }
    insertDiv("mDiv", "M徽章", contM, mArray)

    insertDiv("userDiv", "成就徽章", contUser, userArray)


}

function sortByKey(array, key) {
    return array.sort(function (a, b) {
        var aboolean = a[key];
        var bboolean = b[key];
        if (aboolean) {
            return -1;
        } else if (bboolean) {
            return 1;
        }
        return 0;
    });
}

function insertDiv(divId, title, cont, userArray) {
    //复制模版
    var classdivArray = $(".classify");
    var div = $(classdivArray[0]);
    // console.log(classdivArray);
    var divclone = div.clone();
    divclone.id = divId;
    divclone.show();
    //设置title
    var divTitle = divclone.find(".divTitle");
    divTitle.text(title);
    var num = "(已获得" + cont + "枚)"
    var divnum = divclone.find(".divNumber");
    divnum.text(num);
    //插入item
    var divtable = divclone.find(".tableItem");
    var tabletrArray = divtable.find(".tableTr");
    var tableTrClone = $(tabletrArray[0]);
    var tabletr;
    var itemArray;
    var index = 0;
    for (var i = 0; i < userArray.length; i++) {
        index = i % 3;
        if (index == 0) {
            tabletr = tableTrClone.clone();
            itemArray = tabletr.find(".tableItemDiv");
            tabletr.show();
            divtable.append(tabletr);
        }

        var item = $(itemArray[index]);
        var itemdata = userArray[i];
        item.id = divId + "item" + i;
        item.show();
        item.click(itemdata, itemOnClick);
        var img = item.find(".tableItemImg");
        var name = item.find(".tableItemName");
        name.text(itemdata['name']);
        var day = item.find(".tableItemDay");
        var nTime = itemdata['expire'] - new Date();
        var days = 0;
        if (nTime > 0) {
            days = nTime / (1000 * 60 * 60 * 24);
        }
        var daysRound = Math.floor(days);
        if (itemdata['award']) {
            // if (daysRound < 999){
                day.text("剩余" + daysRound + "天");
            // }else {
            //     day.text("永久点亮");
            // }

            img.attr("src", itemdata['pic_url']);
        } else {
            img.attr("src", itemdata['grey_pic']);
            day.text("  ");
        }
    }

    if (divId == "mDiv" && cont == 0) {
        var divNumberHintView = divclone.find(".divNumberHint");
        divNumberHintView.show()
    }
    if (userArray.length == 0) {
        var divNumberHintView = divclone.find(".divNumberHint");
        divNumberHintView.show()
    }

    divclone.show();
    $('body').append(divclone);

}


function itemOnClick(event) {
    // toast("onclick");
    // setBakckgoundAndOpacity($(this), '#000000', '0.6');
    // var _this = this;
    // setTimeout(function () {
    //     $(_this).css("background-color", "#ffffff");
    // console.log(event.data);
    var itemdata = event.data;
    var img = $(".pop").find("#popImg");
    var name = $(".pop").find("#popName");
    var desc = $(".pop").find("#popDesc");
    name.text(itemdata['name']);
    img.attr("src", itemdata['pic_url']);

    var nTime = itemdata['expire'] - new Date();

    // 一天有多少毫秒
    var MILLIS_PER_DAY = 24 * 60 * 60 * 1000;
    //一小时有多少毫秒
    var MILLIS_PER_HOUR = 60 * 60 * 1000;

    var day = Math.floor(nTime / MILLIS_PER_DAY);
    var hours = Math.floor((nTime % MILLIS_PER_DAY) / MILLIS_PER_HOUR);
    var timeStr = "";
    if (itemdata['award']) {
        // if (day >= 999){
        //     timeStr = "(永久点亮)";
        // }else
        if (day > 0) {
            timeStr = "(剩余" + day + "天" + hours + "小时)";
        } else {
            timeStr = "(剩余" + hours + "小时)";
        }
    }
    var coinhint = $(".pop").find("#popCoin");
    var coinsNum = $(".pop").find("#popBottomNM");
    var sum_cost = itemdata['sum_cost'];
    var coin = itemdata['coins'];

    var sumStr = 0;
    if (sum_cost == undefined) {
        sumStr = "0";
    } else {
        sumStr = sum_cost + "/";
    }

    if (coin == undefined) {
        sumStr += "0";
        coinsNum.hide();
        coinhint.hide();
    } else {
        sumStr += coin;
        coinsNum.show();
        coinhint.show();
    }

    coinsNum.text(sumStr);

    var expirydayhint = $(".pop").find("#popBottomDayHint");
    var expiryday = $(".pop").find("#popBottomDay");
    var day = itemdata['expiry_days'];
    // if (day < 999){
        expirydayhint.show();
        expiryday.text(day + "天");
    // }else {
    //     expirydayhint.hide();
    //     expiryday.text("永久点亮");
    // }

    desc.text(itemdata['desc'] + timeStr);
    event.preventDefault();
    // $(".pop").slideUp(600,function(){
    //     // $(".pop").show();
    // });
    // $(".pop").slideUp(2000);
    // $(".pop").fadeIn(100);

    // $(".pop").show('slow');
    // $(".pop").animate({height:"300px"});
    // }, 200);
    $(".pop").show();
    $(".popMain").animate({bottom:'0px'},500);
    // window.event.cancelBubble = true; //ie s
    window.event.stopPropagation(); //ff s
}

function popOnclick() {
    $(".popMain").animate({bottom:"-300px"},200,function(){
        $(".pop").hide();
    });

    window.event.stopPropagation(); //ff s
}

function popMainOnclick() {
    // window.event.cancelBubble = true; //ie s
    window.event.stopPropagation(); //ff s
}


// 把16进制颜色转换成rgb格式
function colorToRGB(color) {
    var reg = /^#([0-9a-fA-f]{3}|[0-9a-fA-f]{6})$/g;
    var sColor = color.toLowerCase();
    if (sColor && reg.test(sColor)) {
        if (sColor.length === 4) {
            var sColorNew = "#";
            for (var i = 1; i < 4; i += 1) {
                sColorNew += sColor.slice(i, i + 1).concat(sColor.slice(i, i + 1));
            }
            sColor = sColorNew;
        }
        //处理六位的颜色值
        var sColorChange = [];
        for (var i = 1; i < 7; i += 2) {
            sColorChange.push(parseInt("0x" + sColor.slice(i, i + 2)));
        }
        return sColorChange.join(",");
    } else {
        return color;
    }
}

function setBakckgoundAndOpacity(obj, color, opacity) {
    var rgbaObj = colorToRGB(color);

    // 支持rgba颜色格式的浏览器用rgba设置透明背景色
    jQuery(obj).css({
        'background': 'rgba(' + colorToRGB(color) + ',' + opacity + ')'
    });

}


//Toast 提示框
var toast_id = 0;        //外部变量，用来保存setTimeout产生的计时器id
var zindex = 99;　　　　　//这里的z-index可以自己调整，保证在其他元素上不被遮挡
function toast(message, duration) {
    window.clearTimeout(toast_id);    //若短时间内调用两次toast,清除上一次的timeout
    if (document.getElementById("app_toast") != undefined) {
        //上次toast未消失,此时强制停止动画并删除该元素
        $("#app_toast").stop();
        document.body.removeChild(document.getElementById("app_toast"));
    }
    //设置超时时间
    duration = duration == null ? "short" : duration;
    if (duration == "short") duration = 2000;
    else if (duration == "long") duration = 5000;

    //定义新元素
    var div = document.createElement("div");
    div.setAttribute("style", "position:fixed;top:89%;text-align:center;width:95%;z-index:" + zindex);
    div.setAttribute("id", "app_toast");

    //写入innerHTML内容，z-index为app_tpast的z-index值加1，value为提示内容
    div.innerHTML = '<input type="button" id="app_txt_toast" style="padding-left:20px;' +
        'padding-right:20px;border-radius:8px;' +
        'opacity:0.2;height:20px;background:#000000;' +
        'color:#ffffff;border:none;z-index:' + (zindex + 1) + ';' +
        '" value="' + message + '"/>';
    document.body.appendChild(div);　　//向document添加元素

    $("#app_txt_toast").animate({height: '29px', opacity: '0.7'}, 200, function () {
    });
    $("#app_toast").animate({top: '85%'}, 200, function () {
    });　　//制作一个toast从底部滑动效果

    //持续duration毫秒后fadeout
    toast_id = window.setTimeout(function () {
        $("#app_toast").fadeOut(200, function () {
            document.body.removeChild(document.getElementById("app_toast"));
            toast_id = 0;
        })
    }, duration);
}
